## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1.9.0
%bcond_with check

# https://github.com/googleapis/gnostic
%global goipath         github.com/googleapis/gnostic
Version:                0.6.3

%gometa


%global common_description %{expand:
A compiler for APIs described by the OpenAPI Specification with plugins for
code generation and other API support tasks.}

%global golicenses      LICENSE
%global godocs          examples CONTRIBUTING.md README.md surface/README.md\\\
                        linters/README.md linters/go/gnostic-lint-\\\
                        paths/README.md linters/go/gnostic-lint-\\\
                        descriptions/README.md linters/node/gnostic-lint-\\\
                        operations/README.md linters/node/gnostic-lint-\\\
                        responses/README.md printer/README.md generate-\\\
                        gnostic/README.md tools/README.md cmd/disco/README.md\\\
                        examples cmd/protoc-gen-jsonschema/README.md\\\
                        cmd/vocabulary-operations/README.md cmd/petstore-\\\
                        builder/README.md examples cmd/protoc-gen-\\\
                        openapi/README.md cmd/report/README.md cmd/report-\\\
                        messages/README.md discovery/README.md\\\
                        jsonschema/README.md extensions/README.md\\\
                        jsonwriter/README.md openapiv3/README.md\\\
                        openapiv3/schema-generator/3.0.2.md openapiv3/schema-\\\
                        generator/3.0.0.md openapiv3/schema-\\\
                        generator/3.0.1.md openapiv3/schema-\\\
                        generator/3.1.0.md openapiv3/schema-\\\
                        generator/README.md compiler/README.md\\\
                        openapiv2/README.md plugins/README.md\\\
                        plugins/gnostic-analyze/README.md plugins/gnostic-\\\
                        complexity/README.md plugins/gnostic-\\\
                        summary/README.md

Name:           %{goname}
Release:        %autorelease
Summary:        A compiler for APIs described by the OpenAPI Specification with plugins for code generation and other API support tasks

License:        Apache-2.0
URL:            %{gourl}
Source:         %{gosource}

BuildRequires:  golang(github.com/docopt/docopt-go)
BuildRequires:  golang(github.com/golang/protobuf/jsonpb)
BuildRequires:  golang(github.com/golang/protobuf/proto)
BuildRequires:  golang(github.com/golang/protobuf/ptypes)
BuildRequires:  golang(github.com/golang/protobuf/ptypes/any)
BuildRequires:  golang(github.com/google/gnostic/cmd/protoc-gen-jsonschema/generator)
BuildRequires:  golang(github.com/google/gnostic/cmd/protoc-gen-openapi/generator)
BuildRequires:  golang(github.com/google/gnostic/compiler)
BuildRequires:  golang(github.com/google/gnostic/conversions)
BuildRequires:  golang(github.com/google/gnostic/discovery)
BuildRequires:  golang(github.com/google/gnostic/extensions)
BuildRequires:  golang(github.com/google/gnostic/jsonschema)
BuildRequires:  golang(github.com/google/gnostic/jsonwriter)
BuildRequires:  golang(github.com/google/gnostic/lib)
BuildRequires:  golang(github.com/google/gnostic/metrics)
BuildRequires:  golang(github.com/google/gnostic/metrics/lint)
BuildRequires:  golang(github.com/google/gnostic/metrics/rules)
BuildRequires:  golang(github.com/google/gnostic/metrics/vocabulary)
BuildRequires:  golang(github.com/google/gnostic/openapiv2)
BuildRequires:  golang(github.com/google/gnostic/openapiv3)
BuildRequires:  golang(github.com/google/gnostic/plugins)
BuildRequires:  golang(github.com/google/gnostic/plugins/gnostic-analyze/statistics)
BuildRequires:  golang(github.com/google/gnostic/printer)
BuildRequires:  golang(github.com/google/gnostic/surface)
BuildRequires:  golang(github.com/stoewer/go-strcase)
BuildRequires:  golang(golang.org/x/tools/imports)
BuildRequires:  golang(google.golang.org/genproto/googleapis/api/annotations)
BuildRequires:  golang(google.golang.org/protobuf/compiler/protogen)
BuildRequires:  golang(google.golang.org/protobuf/proto)
BuildRequires:  golang(google.golang.org/protobuf/reflect/protoreflect)
BuildRequires:  golang(google.golang.org/protobuf/runtime/protoimpl)
BuildRequires:  golang(google.golang.org/protobuf/types/known/anypb)
BuildRequires:  golang(google.golang.org/protobuf/types/pluginpb)
BuildRequires:  golang(gopkg.in/yaml.v3)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/flowstack/go-jsonschema)
BuildRequires:  golang(gopkg.in/check.v1)
%endif

%description %{common_description}

%gopkg

%prep
%goprep
%autopatch -p1

%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done
%gobuild -o %{gobuilddir}/bin/gnostic %{goipath}
for cmd in tools/format-schema plugins/gnostic-analyze linters/go/gnostic-lint-paths tools/j2y2j linters/go/gnostic-lint-descriptions plugins/gnostic-vocabulary plugins/gnostic-process-plugin-response plugins/gnostic-analyze/summarize plugins/gnostic-summary jsonschema plugins/gnostic-linter plugins/gnostic-plugin-request plugins/gnostic-complexity generate-gnostic openapiv3/schema-generator; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE
%doc examples CONTRIBUTING.md README.md surface/README.md linters/README.md
%doc linters/go/gnostic-lint-paths/README.md
%doc linters/go/gnostic-lint-descriptions/README.md
%doc linters/node/gnostic-lint-operations/README.md
%doc linters/node/gnostic-lint-responses/README.md printer/README.md
%doc generate-gnostic/README.md tools/README.md cmd/disco/README.md examples
%doc cmd/protoc-gen-jsonschema/README.md cmd/vocabulary-operations/README.md
%doc cmd/petstore-builder/README.md examples cmd/protoc-gen-openapi/README.md
%doc cmd/report/README.md cmd/report-messages/README.md discovery/README.md
%doc jsonschema/README.md extensions/README.md jsonwriter/README.md
%doc openapiv3/README.md openapiv3/schema-generator/3.0.2.md
%doc openapiv3/schema-generator/3.0.0.md openapiv3/schema-generator/3.0.1.md
%doc openapiv3/schema-generator/3.1.0.md openapiv3/schema-generator/README.md
%doc compiler/README.md openapiv2/README.md plugins/README.md
%doc plugins/gnostic-analyze/README.md plugins/gnostic-complexity/README.md
%doc plugins/gnostic-summary/README.md
%{_bindir}/*

%gopkgfiles

%changelog
* Wed Apr 26 2023 Sérgio M. Basto <sergio@serjux.com> - 0.6.3-1
- Uncommitted changes

* Wed Apr 26 2023 Sérgio M. Basto <sergio@serjux.com> - 0.5.5-1
- v0.5.5

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.3-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Aug 10 2022 Maxwell G <gotmax@e.email> - 0.5.3-10
- Rebuild to fix FTBFS

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.3-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jul 19 2022 Maxwell G <gotmax@e.email> - 0.5.3-8
- Rebuild for
  CVE-2022-{1705,32148,30631,30633,28131,30635,30632,30630,1962} in golang

* Sat Jun 18 2022 Robert-André Mauchin <zebob.m@gmail.com> - 0.5.3-7
- Rebuilt for CVE-2022-1996, CVE-2022-24675, CVE-2022-28327,
  CVE-2022-27191, CVE-2022-29526, CVE-2022-30629

* Sat Apr 16 2022 Fabio Alessandro Locati <me@fale.io> - 0.5.3-6
- Rebuilt for CVE-2022-27191

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sat Dec 19 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.5.3-2
- Remove failing test

* Sat Dec 19 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.5.3-1
- Update to 0.5.3 Close: rhbz#1887628

* Wed Sep 09 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.5.1-1
- Update to 0.5.1

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sun Jun 14 2020 Robert-André Mauchin <zebob.m@gmail.com> - 0.4.1-1
- Update to 0.4.1

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jun 28 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.0-1
- Initial import
